'use strict';

var _this = this;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _ = require('../');

var _2 = _interopRequireDefault(_);

var _sinon = require('sinon');

function noop() {}

describe('promiseMiddleware', function () {
  var baseDispatch = undefined;
  var dispatch = undefined;
  var foobar = undefined;
  var err = undefined;

  beforeEach(function () {
    baseDispatch = _sinon.spy();
    dispatch = _2['default'](baseDispatch);
    foobar = { foo: 'bar' };
    err = new Error();
  });

  it('handles Flux standard actions', function callee$1$0() {
    return regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          context$2$0.next = 2;
          return regeneratorRuntime.awrap(dispatch({
            type: 'ACTION_TYPE',
            body: Promise.resolve(foobar)
          }));

        case 2:

          expect(baseDispatch.calledOnce).to.be['true'];
          expect(baseDispatch.firstCall.args[0]).to.deep.equal({
            type: 'ACTION_TYPE',
            body: foobar,
            status: 'success'
          });

          context$2$0.next = 6;
          return regeneratorRuntime.awrap(dispatch({
            type: 'ACTION_TYPE',
            body: Promise.reject(err)
          })['catch'](noop));

        case 6:

          expect(baseDispatch.calledTwice).to.be['true'];
          expect(baseDispatch.secondCall.args[0]).to.deep.equal({
            type: 'ACTION_TYPE',
            body: err,
            status: 'error'
          });

        case 8:
        case 'end':
          return context$2$0.stop();
      }
    }, null, _this);
  });

  it('handles promises', function callee$1$0() {
    return regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          context$2$0.next = 2;
          return regeneratorRuntime.awrap(dispatch(Promise.resolve(foobar)));

        case 2:
          expect(baseDispatch.calledOnce).to.be['true'];
          expect(baseDispatch.firstCall.args[0]).to.equal(foobar);

          context$2$0.next = 6;
          return regeneratorRuntime.awrap(expect(dispatch(Promise.reject(err))).to.eventually.be.rejectedWith(err));

        case 6:
        case 'end':
          return context$2$0.stop();
      }
    }, null, _this);
  });
});